import { createStore, applyMiddleware } from 'redux';
import composeReducer from './compose-reducers';

var configureStore = function configureStore(config) {
  var _config$middlewares = config.middlewares,
      middlewares = _config$middlewares === void 0 ? [] : _config$middlewares,
      _config$initialState = config.initialState,
      initialState = _config$initialState === void 0 ? {} : _config$initialState,
      afterCreateStore = config.afterCreateStore,
      reducer = config.reducer;
  var store = createStore(composeReducer(reducer), initialState, applyMiddleware.apply(void 0, middlewares));
  afterCreateStore && afterCreateStore(store);
  return store;
};

export default configureStore;